package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.scale.dao.model.ScaleEntity;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:医院焦虑抑郁量表
 * @date 2021/7/20 15:55
 */
public class HADSScale extends BaseScale{

    public HADSScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {
        //焦虑症状分
        int scoreA = 0;
        //抑郁症状分
        int scoreD = 0;
        List<ScaleEntity> scaleEntities = (List<ScaleEntity>) resultJson.get("scaleEntities");

        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (jsonObject1.getString("scoreDirection").equals("1")) {
                String[] split = scaleEntities.get(i).getCheckItems().split("；");
                if (i % 2 != 0){
                    for (int y = 0; y < split.length; y++){
                        if (jsonObject1.getString("checkItems").equals(split[y])){
                            switch (y){
                                case 1:{
                                    scoreA += 1;
                                    break;
                                }
                                case 2:{
                                    scoreA += 2;
                                    break;
                                }
                                case 3:{
                                    scoreA += 3;
                                    break;
                                }
                            }
                        }
                    }
                }else {
                    for (int y = 0; y < split.length; y++){
                        if (jsonObject1.getString("checkItems").equals(split[y])) {
                            switch (y) {
                                case 1: {
                                    scoreD += 1;
                                    break;
                                }
                                case 2: {
                                    scoreD += 2;
                                    break;
                                }
                                case 3: {
                                    scoreD += 3;
                                    break;
                                }
                            }
                        }
                    }
                }
            } else if (jsonObject1.getString("scoreDirection").equals("0")) {
                String[] split = scaleEntities.get(i).getCheckItems().split("；");
                if (i % 2 != 0){
                    for (int y = 0; y < split.length; y++){
                        if (jsonObject1.getString("checkItems").equals(split[y])){
                            switch (y){
                                case 0:{
                                    scoreA += 3;
                                    break;
                                }
                                case 1:{
                                    scoreA += 2;
                                    break;
                                }
                                case 2:{
                                    scoreA += 1;
                                    break;
                                }
                            }
                        }
                    }
                }else {
                    for (int y = 0; y < split.length; y++){
                        if (jsonObject1.getString("checkItems").equals(split[y])) {
                            switch (y) {
                                case 0: {
                                    scoreD += 3;
                                    break;
                                }
                                case 1: {
                                    scoreD += 2;
                                    break;
                                }
                                case 2: {
                                    scoreD += 1;
                                    break;
                                }
                            }
                        }
                    }
                }
            }
        }
        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("焦虑症状分", String.valueOf(scoreA));
        resultJson.put("焦虑症状分", String.valueOf(scoreA));
        if (scoreA <= 21 && scoreA >= 15){
            resultMap.put("焦虑症状", "经过检测您为【严重焦虑】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。");
            resultJson.put("焦虑症状", "经过检测您为【严重焦虑】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。");
        }else if (scoreA <= 14 && scoreA >= 11 ){
            resultMap.put("焦虑症状", "经过检测您为【中度焦虑】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。");
            resultJson.put("焦虑症状", "经过检测您为【中度焦虑】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。");
        }else if (scoreA <= 10 && scoreA >= 8 ){
            resultMap.put("焦虑症状", "经过检测您为【轻度焦虑】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。");
            resultJson.put("焦虑症状", "经过检测您为【轻度焦虑】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。");
        }else if (scoreA <= 7){
            resultMap.put("焦虑症状", "经过检测您为【正常】，希望您继续保持良好的心情。");
            resultJson.put("焦虑症状", "经过检测您为【正常】，希望您继续保持良好的心情。");
        }
        resultMap.put("抑郁症状分", String.valueOf(scoreD));
        resultJson.put("抑郁症状分", String.valueOf(scoreD));
        if (scoreD <= 21 && scoreD >= 15){
            resultMap.put("抑郁症状", "经过检测您为【严重抑郁】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。");
            resultJson.put("抑郁症状", "经过检测您为【严重抑郁】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。");
        }else if (scoreD <= 14 && scoreD >= 11 ){
            resultMap.put("抑郁症状", "经过检测您为【中度抑郁】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。");
            resultJson.put("抑郁症状", "经过检测您为【中度抑郁】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。");
        }else if (scoreD <= 10 && scoreD >= 8 ){
            resultMap.put("抑郁症状", "经过检测您为【轻度抑郁】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。");
            resultJson.put("抑郁症状", "经过检测您为【轻度抑郁】，为了您和家人的幸福，建议您联系我们，进行更专业的检测。");
        }else if (scoreD <= 7){
            resultMap.put("抑郁症状", "经过检测您为【正常】，希望您继续保持良好的心情。");
            resultJson.put("抑郁症状", "经过检测您为【正常】，希望您继续保持良好的心情。");
        }

        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName",Constant.SHEET_NAME_HADS);
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
